
#define _CRT_SECURE_NO_DEPRECATE
#define WIN32_LEAN_AND_MEAN
#define PETime *(DWORD*)0x400088

#include <windows.h>
#include <stdio.h>

bool Cavern;
SHORT Version;
char Path[MAX_PATH];

WORD SWidth, SHeight, GlobalEatLimit, TargetWidth, TargetHeight;
WORD ScreenX, ScreenY;
DWORD OfflineCavernFloodFix;
DWORD ActualWidth, WUnk2, WUnk3, WUnk4, HorizontalSidesBox, RenderFromLeft;
DWORD HUnk1, CavernWaterEatLimit, ActualHeight, HUnk4, HUnk5, HUnk6, RenderFromTop, HUnk8, VerticalSidesBox;
DWORD SWUnk1, SWUnk2, LeftOffset, CenterCursorX, CenterCursorY;
DWORD TopOffset;

SHORT CheckPE()
{
	if (PETime >= 0x352118A5 && PETime <= 0x352118FD)
		return Version=1;
	return Version=0;
}

BOOL WritePrivateProfileInt(LPCTSTR lpAppName, LPCTSTR lpKeyName, int nInteger, LPCTSTR lpFileName)
{
	TCHAR lpString[32];
	wsprintf(lpString, "%d", nInteger);
	return WritePrivateProfileString( lpAppName, lpKeyName, lpString, lpFileName );
}

BOOL Unprotect(DWORD addr, SIZE_T dwSize = 2)
{
	DWORD whyamineeded;
	return VirtualProtect((void*)addr,dwSize,PAGE_READWRITE,&whyamineeded);
}

LPCSTR GetPathToFile(LPCSTR FileName)
{
	GetModuleFileName(NULL,Path,MAX_PATH);
	char* dirend=strrchr(Path,'\\')+1;
	strcpy(dirend,FileName);
	return Path;
}

BOOL CavernCheck()
{
	FILE* land;
	char cavc;
	Cavern = false;
	TargetWidth = SWidth > 6012 ? 6012 : SWidth;
	TargetHeight = SHeight > 2902 ? 2902 : SHeight;

	if (land = fopen(GetPathToFile("Data\\land.dat"),"r"))
	{
		fseek(land, 0x10, SEEK_SET);
		cavc = fgetc(land);
		if (cavc)
		{
			Cavern = true;
			TargetWidth = SWidth > 1920 ? 1920 : SWidth;
			TargetHeight = SHeight > 856 ? 856 : SHeight;
		}
		fclose(land);
	}
	else
		MessageBox(NULL, "Warning: failed to open Data\\land.dat file. Your game will most likely crash.", "ReSolution warning", MB_OK | MB_ICONWARNING);
	
	return Cavern;
}

void GetAddresses()
{
	//credits for these go to S*natch and des

	ActualWidth	        = 0x00033292 + 0x400C00;
	WUnk2               = 0x00045AB3 + 0x400C00;
	WUnk3               = 0x00045AD7 + 0x400C00;
	WUnk4               = 0x00045B1D + 0x400C00;
	HorizontalSidesBox  = 0x00045B40 + 0x400C00;
	RenderFromLeft      = 0x00045B78 + 0x400C00;
	HUnk1               = 0x000279E9 + 0x400C00;
	CavernWaterEatLimit = 0x000279F6 + 0x400C00;
	ActualHeight        = 0x0003328A + 0x400C00;
	HUnk4               = 0x000363F6 + 0x400C00;
	HUnk5               = 0x0004000C + 0x400C00;
	HUnk6               = 0x00045B18 + 0x400C00;
	RenderFromTop       = 0x00045B73 + 0x400C00;
	HUnk8               = 0x00045ADC + 0x400C00;
	VerticalSidesBox    = 0x00045B55 + 0x400C00;
	SWUnk1              = 0x00045A9C + 0x400C00;
	SWUnk2              = 0x00045B07 + 0x400C00;
	LeftOffset          = 0x00045B4D + 0x400C00;
	TopOffset           = 0x00045B38 + 0x400C00;

	//new things discovered by StepS

	CenterCursorX       = 0x00077878 + 0x401C00;
	CenterCursorY       = 0x0007787C + 0x401C00;
}

void UnprotectAddresses()
{
	Unprotect(ActualWidth);
	Unprotect(CavernWaterEatLimit);
	Unprotect(HUnk4);
	Unprotect(HUnk5);
	Unprotect(TopOffset);
}

void PatchMem()
{
	*(WORD*)ActualWidth         = SWidth;
	*(WORD*)WUnk2               = SWidth;
	*(WORD*)WUnk3               = SWidth;
	*(WORD*)WUnk4               = SWidth;
	*(WORD*)RenderFromLeft      = TargetWidth;
	*(WORD*)HorizontalSidesBox  = TargetWidth;
	*(WORD*)HUnk1               = SHeight;
	*(WORD*)CavernWaterEatLimit = GlobalEatLimit;
	*(WORD*)ActualHeight        = SHeight;
	*(WORD*)HUnk4               = SHeight;
	*(WORD*)HUnk5               = SHeight;
	*(WORD*)HUnk6               = SHeight;
	*(WORD*)RenderFromTop       = TargetHeight;
	*(WORD*)HUnk8               = TargetHeight;
	*(WORD*)VerticalSidesBox    = TargetHeight;
	*(WORD*)LeftOffset          = TargetWidth/2;
	*(WORD*)TopOffset           = TargetHeight/2;
	*(WORD*)SWUnk1 = SWidth/2;
	*(WORD*)SWUnk2 = SWidth/2;
	*(WORD*)CenterCursorX = SWidth/2;
	*(WORD*)CenterCursorY = SHeight/2;

	if (SWidth/2 > ScreenX/2)
	  *(WORD*)CenterCursorX = ScreenX/2;
	if (SHeight/2 > ScreenY/2)
	  *(WORD*)CenterCursorY = ScreenY/2;
}

void LoadConfig()
{
	LPCSTR Config = GetPathToFile("W2.ini");

	SWidth = GetPrivateProfileInt("Resolution","ScreenWidth",-1,Config);
	SHeight = GetPrivateProfileInt("Resolution","ScreenHeight",-1,Config);
	OfflineCavernFloodFix = GetPrivateProfileInt("Resolution","OfflineCavernFloodFix",1,Config);

	ScreenX = GetSystemMetrics(SM_CXSCREEN);
	ScreenY = GetSystemMetrics(SM_CYSCREEN);

	if (SWidth <= 0 || SHeight <= 0)
	{
		SWidth = ScreenX;
		SHeight = ScreenY;
		WritePrivateProfileInt("Resolution","ScreenWidth",SWidth,Config);
		WritePrivateProfileInt("Resolution","ScreenHeight",SHeight,Config);
	}

	if (OfflineCavernFloodFix)
		GlobalEatLimit = 854;
	else
		GlobalEatLimit = 480;
}

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	if(ul_reason_for_call==DLL_PROCESS_ATTACH)
	{
		if (!CheckPE())
		{
			MessageBox(NULL,"Sorry, but your Worms2.exe version has to be 1.05 for wkReSolution to work. Please patch your game to 1.05 and try again.","ReSolution error",NULL);
			return 1;
		}
		LoadConfig();
		CavernCheck();
		GetAddresses();
		UnprotectAddresses();
		PatchMem();
	}

	if(ul_reason_for_call==DLL_PROCESS_DETACH)
	{

	}

	return 1;
}

